/*******************************************************************************
* File Name: D0.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_D0_H) /* Pins D0_H */
#define CY_PINS_D0_H

#include "cytypes.h"
#include "cyfitter.h"
#include "D0_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    D0_Write(uint8 value) ;
void    D0_SetDriveMode(uint8 mode) ;
uint8   D0_ReadDataReg(void) ;
uint8   D0_Read(void) ;
uint8   D0_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define D0_DRIVE_MODE_BITS        (3)
#define D0_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - D0_DRIVE_MODE_BITS))

#define D0_DM_ALG_HIZ         (0x00u)
#define D0_DM_DIG_HIZ         (0x01u)
#define D0_DM_RES_UP          (0x02u)
#define D0_DM_RES_DWN         (0x03u)
#define D0_DM_OD_LO           (0x04u)
#define D0_DM_OD_HI           (0x05u)
#define D0_DM_STRONG          (0x06u)
#define D0_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define D0_MASK               D0__MASK
#define D0_SHIFT              D0__SHIFT
#define D0_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define D0_PS                     (* (reg32 *) D0__PS)
/* Port Configuration */
#define D0_PC                     (* (reg32 *) D0__PC)
/* Data Register */
#define D0_DR                     (* (reg32 *) D0__DR)
/* Input Buffer Disable Override */
#define D0_INP_DIS                (* (reg32 *) D0__PC2)


#if defined(D0__INTSTAT)  /* Interrupt Registers */

    #define D0_INTSTAT                (* (reg32 *) D0__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define D0_DRIVE_MODE_SHIFT       (0x00u)
#define D0_DRIVE_MODE_MASK        (0x07u << D0_DRIVE_MODE_SHIFT)


#endif /* End Pins D0_H */


/* [] END OF FILE */
