/*******************************************************************************
* File Name: D1.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_D1_H) /* Pins D1_H */
#define CY_PINS_D1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "D1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    D1_Write(uint8 value) ;
void    D1_SetDriveMode(uint8 mode) ;
uint8   D1_ReadDataReg(void) ;
uint8   D1_Read(void) ;
uint8   D1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define D1_DRIVE_MODE_BITS        (3)
#define D1_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - D1_DRIVE_MODE_BITS))

#define D1_DM_ALG_HIZ         (0x00u)
#define D1_DM_DIG_HIZ         (0x01u)
#define D1_DM_RES_UP          (0x02u)
#define D1_DM_RES_DWN         (0x03u)
#define D1_DM_OD_LO           (0x04u)
#define D1_DM_OD_HI           (0x05u)
#define D1_DM_STRONG          (0x06u)
#define D1_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define D1_MASK               D1__MASK
#define D1_SHIFT              D1__SHIFT
#define D1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define D1_PS                     (* (reg32 *) D1__PS)
/* Port Configuration */
#define D1_PC                     (* (reg32 *) D1__PC)
/* Data Register */
#define D1_DR                     (* (reg32 *) D1__DR)
/* Input Buffer Disable Override */
#define D1_INP_DIS                (* (reg32 *) D1__PC2)


#if defined(D1__INTSTAT)  /* Interrupt Registers */

    #define D1_INTSTAT                (* (reg32 *) D1__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define D1_DRIVE_MODE_SHIFT       (0x00u)
#define D1_DRIVE_MODE_MASK        (0x07u << D1_DRIVE_MODE_SHIFT)


#endif /* End Pins D1_H */


/* [] END OF FILE */
