/*******************************************************************************
* File Name: SignalHighISR.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_SignalHighISR_H)
#define CY_ISR_SignalHighISR_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void SignalHighISR_Start(void);
void SignalHighISR_StartEx(cyisraddress address);
void SignalHighISR_Stop(void);

CY_ISR_PROTO(SignalHighISR_Interrupt);

void SignalHighISR_SetVector(cyisraddress address);
cyisraddress SignalHighISR_GetVector(void);

void SignalHighISR_SetPriority(uint8 priority);
uint8 SignalHighISR_GetPriority(void);

void SignalHighISR_Enable(void);
uint8 SignalHighISR_GetState(void);
void SignalHighISR_Disable(void);

void SignalHighISR_SetPending(void);
void SignalHighISR_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the SignalHighISR ISR. */
#define SignalHighISR_INTC_VECTOR            ((reg32 *) SignalHighISR__INTC_VECT)

/* Address of the SignalHighISR ISR priority. */
#define SignalHighISR_INTC_PRIOR             ((reg32 *) SignalHighISR__INTC_PRIOR_REG)

/* Priority of the SignalHighISR interrupt. */
#define SignalHighISR_INTC_PRIOR_NUMBER      SignalHighISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable SignalHighISR interrupt. */
#define SignalHighISR_INTC_SET_EN            ((reg32 *) SignalHighISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the SignalHighISR interrupt. */
#define SignalHighISR_INTC_CLR_EN            ((reg32 *) SignalHighISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the SignalHighISR interrupt state to pending. */
#define SignalHighISR_INTC_SET_PD            ((reg32 *) SignalHighISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the SignalHighISR interrupt. */
#define SignalHighISR_INTC_CLR_PD            ((reg32 *) SignalHighISR__INTC_CLR_PD_REG)



#endif /* CY_ISR_SignalHighISR_H */


/* [] END OF FILE */
