/*******************************************************************************
* File Name: SignalLowISR.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_SignalLowISR_H)
#define CY_ISR_SignalLowISR_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void SignalLowISR_Start(void);
void SignalLowISR_StartEx(cyisraddress address);
void SignalLowISR_Stop(void);

CY_ISR_PROTO(SignalLowISR_Interrupt);

void SignalLowISR_SetVector(cyisraddress address);
cyisraddress SignalLowISR_GetVector(void);

void SignalLowISR_SetPriority(uint8 priority);
uint8 SignalLowISR_GetPriority(void);

void SignalLowISR_Enable(void);
uint8 SignalLowISR_GetState(void);
void SignalLowISR_Disable(void);

void SignalLowISR_SetPending(void);
void SignalLowISR_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the SignalLowISR ISR. */
#define SignalLowISR_INTC_VECTOR            ((reg32 *) SignalLowISR__INTC_VECT)

/* Address of the SignalLowISR ISR priority. */
#define SignalLowISR_INTC_PRIOR             ((reg32 *) SignalLowISR__INTC_PRIOR_REG)

/* Priority of the SignalLowISR interrupt. */
#define SignalLowISR_INTC_PRIOR_NUMBER      SignalLowISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable SignalLowISR interrupt. */
#define SignalLowISR_INTC_SET_EN            ((reg32 *) SignalLowISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the SignalLowISR interrupt. */
#define SignalLowISR_INTC_CLR_EN            ((reg32 *) SignalLowISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the SignalLowISR interrupt state to pending. */
#define SignalLowISR_INTC_SET_PD            ((reg32 *) SignalLowISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the SignalLowISR interrupt. */
#define SignalLowISR_INTC_CLR_PD            ((reg32 *) SignalLowISR__INTC_CLR_PD_REG)



#endif /* CY_ISR_SignalLowISR_H */


/* [] END OF FILE */
