/*******************************************************************************
* File Name: UltrasoundPWMClock.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_UltrasoundPWMClock_H)
#define CY_CLOCK_UltrasoundPWMClock_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void UltrasoundPWMClock_StartEx(uint32 alignClkDiv);
#define UltrasoundPWMClock_Start() \
    UltrasoundPWMClock_StartEx(UltrasoundPWMClock__PA_DIV_ID)

#else

void UltrasoundPWMClock_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void UltrasoundPWMClock_Stop(void);

void UltrasoundPWMClock_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 UltrasoundPWMClock_GetDividerRegister(void);
uint8  UltrasoundPWMClock_GetFractionalDividerRegister(void);

#define UltrasoundPWMClock_Enable()                         UltrasoundPWMClock_Start()
#define UltrasoundPWMClock_Disable()                        UltrasoundPWMClock_Stop()
#define UltrasoundPWMClock_SetDividerRegister(clkDivider, reset)  \
    UltrasoundPWMClock_SetFractionalDividerRegister((clkDivider), 0u)
#define UltrasoundPWMClock_SetDivider(clkDivider)           UltrasoundPWMClock_SetDividerRegister((clkDivider), 1u)
#define UltrasoundPWMClock_SetDividerValue(clkDivider)      UltrasoundPWMClock_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define UltrasoundPWMClock_DIV_ID     UltrasoundPWMClock__DIV_ID

#define UltrasoundPWMClock_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define UltrasoundPWMClock_CTRL_REG   (*(reg32 *)UltrasoundPWMClock__CTRL_REGISTER)
#define UltrasoundPWMClock_DIV_REG    (*(reg32 *)UltrasoundPWMClock__DIV_REGISTER)

#define UltrasoundPWMClock_CMD_DIV_SHIFT          (0u)
#define UltrasoundPWMClock_CMD_PA_DIV_SHIFT       (8u)
#define UltrasoundPWMClock_CMD_DISABLE_SHIFT      (30u)
#define UltrasoundPWMClock_CMD_ENABLE_SHIFT       (31u)

#define UltrasoundPWMClock_CMD_DISABLE_MASK       ((uint32)((uint32)1u << UltrasoundPWMClock_CMD_DISABLE_SHIFT))
#define UltrasoundPWMClock_CMD_ENABLE_MASK        ((uint32)((uint32)1u << UltrasoundPWMClock_CMD_ENABLE_SHIFT))

#define UltrasoundPWMClock_DIV_FRAC_MASK  (0x000000F8u)
#define UltrasoundPWMClock_DIV_FRAC_SHIFT (3u)
#define UltrasoundPWMClock_DIV_INT_MASK   (0xFFFFFF00u)
#define UltrasoundPWMClock_DIV_INT_SHIFT  (8u)

#else 

#define UltrasoundPWMClock_DIV_REG        (*(reg32 *)UltrasoundPWMClock__REGISTER)
#define UltrasoundPWMClock_ENABLE_REG     UltrasoundPWMClock_DIV_REG
#define UltrasoundPWMClock_DIV_FRAC_MASK  UltrasoundPWMClock__FRAC_MASK
#define UltrasoundPWMClock_DIV_FRAC_SHIFT (16u)
#define UltrasoundPWMClock_DIV_INT_MASK   UltrasoundPWMClock__DIVIDER_MASK
#define UltrasoundPWMClock_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_UltrasoundPWMClock_H) */

/* [] END OF FILE */
