/*******************************************************************************
* File Name: UltrasoundResponse.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_UltrasoundResponse_H) /* Pins UltrasoundResponse_H */
#define CY_PINS_UltrasoundResponse_H

#include "cytypes.h"
#include "cyfitter.h"
#include "UltrasoundResponse_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    UltrasoundResponse_Write(uint8 value) ;
void    UltrasoundResponse_SetDriveMode(uint8 mode) ;
uint8   UltrasoundResponse_ReadDataReg(void) ;
uint8   UltrasoundResponse_Read(void) ;
uint8   UltrasoundResponse_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define UltrasoundResponse_DRIVE_MODE_BITS        (3)
#define UltrasoundResponse_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - UltrasoundResponse_DRIVE_MODE_BITS))

#define UltrasoundResponse_DM_ALG_HIZ         (0x00u)
#define UltrasoundResponse_DM_DIG_HIZ         (0x01u)
#define UltrasoundResponse_DM_RES_UP          (0x02u)
#define UltrasoundResponse_DM_RES_DWN         (0x03u)
#define UltrasoundResponse_DM_OD_LO           (0x04u)
#define UltrasoundResponse_DM_OD_HI           (0x05u)
#define UltrasoundResponse_DM_STRONG          (0x06u)
#define UltrasoundResponse_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define UltrasoundResponse_MASK               UltrasoundResponse__MASK
#define UltrasoundResponse_SHIFT              UltrasoundResponse__SHIFT
#define UltrasoundResponse_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define UltrasoundResponse_PS                     (* (reg32 *) UltrasoundResponse__PS)
/* Port Configuration */
#define UltrasoundResponse_PC                     (* (reg32 *) UltrasoundResponse__PC)
/* Data Register */
#define UltrasoundResponse_DR                     (* (reg32 *) UltrasoundResponse__DR)
/* Input Buffer Disable Override */
#define UltrasoundResponse_INP_DIS                (* (reg32 *) UltrasoundResponse__PC2)


#if defined(UltrasoundResponse__INTSTAT)  /* Interrupt Registers */

    #define UltrasoundResponse_INTSTAT                (* (reg32 *) UltrasoundResponse__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define UltrasoundResponse_DRIVE_MODE_SHIFT       (0x00u)
#define UltrasoundResponse_DRIVE_MODE_MASK        (0x07u << UltrasoundResponse_DRIVE_MODE_SHIFT)


#endif /* End Pins UltrasoundResponse_H */


/* [] END OF FILE */
