/*******************************************************************************
* File Name: UltrasoundTrigger.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_UltrasoundTrigger_H) /* Pins UltrasoundTrigger_H */
#define CY_PINS_UltrasoundTrigger_H

#include "cytypes.h"
#include "cyfitter.h"
#include "UltrasoundTrigger_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    UltrasoundTrigger_Write(uint8 value) ;
void    UltrasoundTrigger_SetDriveMode(uint8 mode) ;
uint8   UltrasoundTrigger_ReadDataReg(void) ;
uint8   UltrasoundTrigger_Read(void) ;
uint8   UltrasoundTrigger_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define UltrasoundTrigger_DRIVE_MODE_BITS        (3)
#define UltrasoundTrigger_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - UltrasoundTrigger_DRIVE_MODE_BITS))

#define UltrasoundTrigger_DM_ALG_HIZ         (0x00u)
#define UltrasoundTrigger_DM_DIG_HIZ         (0x01u)
#define UltrasoundTrigger_DM_RES_UP          (0x02u)
#define UltrasoundTrigger_DM_RES_DWN         (0x03u)
#define UltrasoundTrigger_DM_OD_LO           (0x04u)
#define UltrasoundTrigger_DM_OD_HI           (0x05u)
#define UltrasoundTrigger_DM_STRONG          (0x06u)
#define UltrasoundTrigger_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define UltrasoundTrigger_MASK               UltrasoundTrigger__MASK
#define UltrasoundTrigger_SHIFT              UltrasoundTrigger__SHIFT
#define UltrasoundTrigger_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define UltrasoundTrigger_PS                     (* (reg32 *) UltrasoundTrigger__PS)
/* Port Configuration */
#define UltrasoundTrigger_PC                     (* (reg32 *) UltrasoundTrigger__PC)
/* Data Register */
#define UltrasoundTrigger_DR                     (* (reg32 *) UltrasoundTrigger__DR)
/* Input Buffer Disable Override */
#define UltrasoundTrigger_INP_DIS                (* (reg32 *) UltrasoundTrigger__PC2)


#if defined(UltrasoundTrigger__INTSTAT)  /* Interrupt Registers */

    #define UltrasoundTrigger_INTSTAT                (* (reg32 *) UltrasoundTrigger__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define UltrasoundTrigger_DRIVE_MODE_SHIFT       (0x00u)
#define UltrasoundTrigger_DRIVE_MODE_MASK        (0x07u << UltrasoundTrigger_DRIVE_MODE_SHIFT)


#endif /* End Pins UltrasoundTrigger_H */


/* [] END OF FILE */
