/*******************************************************************************
* File Name: UltrasoundTrigger2.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_UltrasoundTrigger2_H) /* Pins UltrasoundTrigger2_H */
#define CY_PINS_UltrasoundTrigger2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "UltrasoundTrigger2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    UltrasoundTrigger2_Write(uint8 value) ;
void    UltrasoundTrigger2_SetDriveMode(uint8 mode) ;
uint8   UltrasoundTrigger2_ReadDataReg(void) ;
uint8   UltrasoundTrigger2_Read(void) ;
uint8   UltrasoundTrigger2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define UltrasoundTrigger2_DRIVE_MODE_BITS        (3)
#define UltrasoundTrigger2_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - UltrasoundTrigger2_DRIVE_MODE_BITS))

#define UltrasoundTrigger2_DM_ALG_HIZ         (0x00u)
#define UltrasoundTrigger2_DM_DIG_HIZ         (0x01u)
#define UltrasoundTrigger2_DM_RES_UP          (0x02u)
#define UltrasoundTrigger2_DM_RES_DWN         (0x03u)
#define UltrasoundTrigger2_DM_OD_LO           (0x04u)
#define UltrasoundTrigger2_DM_OD_HI           (0x05u)
#define UltrasoundTrigger2_DM_STRONG          (0x06u)
#define UltrasoundTrigger2_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define UltrasoundTrigger2_MASK               UltrasoundTrigger2__MASK
#define UltrasoundTrigger2_SHIFT              UltrasoundTrigger2__SHIFT
#define UltrasoundTrigger2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define UltrasoundTrigger2_PS                     (* (reg32 *) UltrasoundTrigger2__PS)
/* Port Configuration */
#define UltrasoundTrigger2_PC                     (* (reg32 *) UltrasoundTrigger2__PC)
/* Data Register */
#define UltrasoundTrigger2_DR                     (* (reg32 *) UltrasoundTrigger2__DR)
/* Input Buffer Disable Override */
#define UltrasoundTrigger2_INP_DIS                (* (reg32 *) UltrasoundTrigger2__PC2)


#if defined(UltrasoundTrigger2__INTSTAT)  /* Interrupt Registers */

    #define UltrasoundTrigger2_INTSTAT                (* (reg32 *) UltrasoundTrigger2__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define UltrasoundTrigger2_DRIVE_MODE_SHIFT       (0x00u)
#define UltrasoundTrigger2_DRIVE_MODE_MASK        (0x07u << UltrasoundTrigger2_DRIVE_MODE_SHIFT)


#endif /* End Pins UltrasoundTrigger2_H */


/* [] END OF FILE */
